package server;
import interfaces.*;

import java.rmi.*;
import java.rmi.server.*;
 

public class Server extends UnicastRemoteObject
                    implements Executor
{

    public final static String name = "//127.0.0.1/Executor";
    
    public Server() throws RemoteException {
        super();
    }


    public static void main(String[] s) {
        try {
            Executor server = new Server();
            Naming.rebind(name, server);
            System.out.println("Bound");
        } catch (Exception e) {
            System.err.println("Exception: " + e.getMessage());
            e.printStackTrace();
        }
    }


    //-------------------------------------------------------------------
    // Implementation of the Executor interface
    
    public Object execute(Task task) throws RemoteException {
	System.out.println("Server received command. Starting calculations");
	Object ret = task.run();
	System.out.println("Server ended calculation. Returning value");
	return ret;
    }

}
